import tools.*;
import io.*;

import java.io.*;

class TestProgram extends Program {
  boolean passed= true;
  void run() {
    // setLogFile("console.log");
    for(int i=0; i<8;i++) print(repeat(""+i, 10));
    println("");
    for(int i=0; i<8;i++) print("0123456789");
    println("");
    check("length(String)", length("hola"), 4);
    int[] v1={ 1, 2, 3};
    check("length(int[])", length(v1), 3);
    double[] v2={ 1, 2, 3, 4, 5};
    check("length(double[])", length(v2), 5);
    boolean[] v3={ true, false };
    check("length(boolean[])", length(v3), 2);
    String[] v4={ "true", "false", "1", "2", "3", "4"};
    check("length(Object[])", length(v4), 6);

    check("sin(PI)", sin(PI), 0);
    check("cos(PI)", cos(PI), -1);
    check("tan(PI)", tan(PI), 0);
    check("asin(1)", asin(1), PI/2);
    check("acos(1)", acos(1), 0);
    check("atan(0)", atan(0), 0);

    check("exp(1)", exp(1), E);
    check("log(1)", log(1), 0);
    check("pow(2, 3)", pow(2, 3), 8);
    check("pow(2., 3.)", pow(2., 3.), 8.);

    check("sqrt(4)", sqrt(4), 2);

    check("ceil(1.5)", ceil(1.5), 2);
    check("floor(1.5)", floor(1.5), 1);
    check("trunc(2.5)", trunc(2.5), 2);

    try { 
      trunc(pow(2.,31));
      println("trunc(pow(2.,31)) not passed");
    }
    catch (ArithmeticException excp) {
      println("trunc(pow(2.,31)) passed");
    }

    try { 
      check("trunc(pow(2.,31)-1)", trunc(pow(2.,31)-1), Integer.MAX_VALUE);
    }
    catch (ArithmeticException excp) {
      println("trunc(pow(2.,31)-1) not passed");
    }

    try { 
      trunc(-pow(2.,31)-1.0);
      println("trunc(-pow(2.,31)-1.0) not passed");
    }
    catch (ArithmeticException excp) {
      println("trunc(-pow(2.,31)-1.0) passed");
    }

    try { 
      check("trunc(-pow(2.,31))", trunc(-pow(2.,31)), Integer.MIN_VALUE);
    }
    catch (ArithmeticException excp) {
      println("trunc(-pow(2.,31)) not passed");
    }

    println("random() "+random()+" passed.");
    check("abs(-1)", abs(-1), 1);
    check("abs(-1.)", abs(-1.), 1);

    check("max(1, 2)", max(1, 2), 2);
    check("max(1., 2.)", max(1., 2.), 2.);
    check("min(1, 2)", min(1, 2), 1);
    check("min(1., 2.)", min(1., 2.), 1.);

    check("round(PI, 3)", round(PI, 3), 3.142);

    println("Strings");
    check("compare(\"a\",\"b\")", compare("a","b"), -1);
    check("substring(\"0123456789\", 5, 2)",
          substring("0123456789", 5, 2), "56");
    check("substring(\"0123456789\", 5)",
          substring("0123456789", 5), "56789");
    check("repeat(\"ab\", 5)", repeat("ab", 5), "ababababab");
    check("replace(\"abracadabra\",\"a\",\"e\")",
          replace("abracadabra", "a", "e"), "ebrecedebre");
    check("replace(\"hola\",\"gg\", \"\")",
          replace("hola","gg",""), "hola");
    check("replace(\"este te gustara\",\"te\",\"TEE\")",
          replace("este te gustara", "te", "TEE"), "esTEE TEE gustara");
    check("replace(\"\",\"a\",\"b\")",
          replace("","a","b"), "");
    check("trim(\"  hola que  tal \")",
          trim("  hola que  tal "), "hola que  tal");

    check("lower(\"Hola\")", lower("Hola"), "hola");
    check("upper(\"Hola\")", upper("Hola"), "HOLA");
    check("isInt(\"123\")", isInt("123"), true);
    check("isInt(\"123a\")", isInt("123a"), false);
    check("isDouble(\"123\")", isDouble("123"), true);
    check("isDouble(\"123.\")", isDouble("123."), true);
    check("isDouble(\"123a\")", isDouble("123a"), false);

    println("Lectura de la consola");
    print("Ingrese una lnea que diga hola: ");
    check("readString()", readString(), "hola");
    println("Ingrese una lnea que diga como te va: ");
    check("readLine()", readLine(), "como te va");
    print("Ingrese el numero 5: ");
    check("readInt()", readInt(), 5);
    print("Ingrese el numero 3.14: ");
    check("readDouble()", readDouble(), 3.14);
    print("Ingrese una lnea que diga true: ");
    check("readBoolean()", readBoolean(), true);

    // Test input/output
    {
    print("Ingrese el nombre de un archivo en donde se pueda escribir: ");
    String fn= readLine();
    File file= new File(fn);
    // if (!file.canWrite())
    //   fatalError("Sorry, I can't write file "+fn);
    
    // Escribimos en el archivo
    TextWriter out= new TextWriter(fn);
    out.println("Hola que tal");
    out.println("Hola que tal");
    out.println("Hola que tal");
    out.println("Hola que tal");
    out.println(" \tHola \thola \t");
    out.println("Hola que tal");
    out.println();
    out.println("5 5.0 chao \t");
    out.close();
    
    // Ahora lo leemos
    TextReader in= new TextReader(fn);
    // primera linea
    check("readLine(): Hola que tal", in.readLine(), "Hola que tal");
    // segunda linea
    check("readString(): Hola", in.readString(), "Hola");
    check("readString(): que", in.readString(), "que");
    check("readString(): tal", in.readString(), "tal");
    // tercera linea
    check("readLine(): Hola que tal", in.readLine(), "Hola que tal");
    // cuarta linea
    check("readString(): Hola", in.readString(), "Hola");
    check("readLine(): que tal", in.readLine(), "que tal");
    // quinta linea
    check("readString(): Hola", in.readString(), "Hola");
    check("readString(): hola", in.readString(), "hola");
    // sexta linea
    check("readLine(): Hola que tal", in.readLine(), "Hola que tal");
    // datos numericos
    check("readInt(): 5", in.readInt(), 5);
    check("readDouble(): 5.0", in.readDouble(), 5.0);
    check("readLine(): chao", in.readLine(), "chao \t");
    // fin de archivo
    check("eofReached(): false", in.eofReached(), false);
    check("readDouble(): 0.0", in.readDouble(), 0.0);
    check("eofReached(): true", in.eofReached(), true);
    try {
      print("Allowing reading after end-of file ... ");
      for(int i=0; i<TextReader.MAXEOFCOUNT-1; i++)
        in.readInt();
      println("passed");
    }
    catch (ProgramException excp) {
      println("not passed");
      passed= false;
    }
    try {
      print("Testing infinite loop protection ... ");
      in.readInt();
      println("not passed");
      passed= false;
    }
    catch (ProgramException excp) {
      println("passed");
    }
    in.close();
    file.delete();
    }

    // Test FieldParser
    {
    FieldParser parser= new FieldParser("hola:que:tal",":");
    check("readString(): hola", parser.readString(), "hola");
    check("readString(): que", parser.readString(), "que");
    check("hasMoreFields(): true", parser.hasMoreFields(), true);
    check("readString(): tal", parser.readString(), "tal");
    check("hasMoreFields(): false", parser.hasMoreFields(), false);
    check("eosReached(): false", parser.eosReached(), false);
    check("readString(): null", parser.readString(), null);
    check("eosReached(): true", parser.eosReached(), true);
    FieldParser parser2= new FieldParser(":",":");
    check("readString(): ", parser2.readString(), "");
    check("readString(): ", parser2.readString(), "");
    check("readString(): null", parser2.readString(), null);
    }

    // Test WordParser
    {
    WordParser parser= new WordParser(" hola \t que  tal\t");
    check("readString(): hola", parser.readString(), "hola");
    check("readString(): que", parser.readString(), "que");
    check("hasMoreWords(): true", parser.hasMoreWords(), true);
    check("readString(): tal", parser.readString(), "tal");
    check("hasMoreWords(): false", parser.hasMoreWords(), false);
    check("eosReached(): false", parser.eosReached(), false);
    check("readString(): null", parser.readString(), null);
    check("eosReached(): true", parser.eosReached(), true);
    WordParser parser2= new WordParser(" \t");
    check("hasMoreWords(): false", parser2.hasMoreWords(), false);
    check("readString(): ", parser2.readString(), null);
    }

    // Test Map
    {
    Map map= new Map();
    map.put(5, 1000);
    map.put(8, 3.14);
    map.put(20, true);
    map.put(30, "hello");

    check("size(): 4", map.size(), 4);
    check("getInt(5): 1000", map.getInt(5), 1000);
    check("getDouble(8): 3.14", map.getDouble(8), 3.14);
    check("getBoolean(20): true", map.getBoolean(20), true);
    check("getString(30): hello", map.getString(30), "hello");

    // Check isMapped

    check("isMapped(5): true", map.isMapped(5), true);
    check("isMapped(8): true", map.isMapped(8), true);
    check("isMapped(20): true", map.isMapped(20), true);
    check("isMapped(30): true", map.isMapped(30), true);
    check("isMapped(6): false", map.isMapped(6), false);

    // Check is<type>

    check("isInt(5): true", map.isInt(5), true);
    check("isDouble(5): true", map.isDouble(5), true);
    check("isBoolean(5): false", map.isBoolean(5), false);
    check("isString(5): false", map.isString(5), false);

    check("isInt(8): false", map.isInt(8), false);
    check("isDouble(8): true", map.isDouble(8), true);
    check("isBoolean(8): false", map.isBoolean(8), false);
    check("isString(8): false", map.isString(8), false);

    check("isInt(20): false", map.isInt(20), false);
    check("isDouble(20): false", map.isDouble(20), false);
    check("isBoolean(20): true", map.isBoolean(20), true);
    check("isString(20): false", map.isString(20), false);

    check("isInt(30): false", map.isInt(30), false);
    check("isDouble(30): false", map.isDouble(30), false);
    check("isBoolean(30): false", map.isBoolean(30), false);
    check("isString(30): true", map.isString(30), true);

    // Eliminaciones
    map.remove(5);
    check("remove(5)", map.isMapped(5), false);

    // Enumeracion con llaves enteras
    Map map2= new Map();
    map2.put(1, "uno");
    map2.put(2, "dos");
    KeyEnum enum= map2.keys();
    check("nextKey()", enum.nextKey(), 2);
    check("hasMoreKeys()", enum.hasMoreKeys(), true);
    check("nextKey()", enum.nextKey(), 1);
    check("hasMoreKeys()", enum.hasMoreKeys(), false);
    }

    // Test StringMap

    {
    StringMap map= new StringMap();
    map.put("hi", 3000);
    map.put("bye", 2.7);
    map.put("why", false);
    map.put("speed", "light");

    // Check get and put

    check("size(): 4", map.size(), 4);
    check("getInt(\"hi\"): 3000", map.getInt("hi"), 3000);
    check("getDouble(\"bye\"): 2.7", map.getDouble("bye"), 2.7);
    check("getBoolean(\"why\"): false", map.getBoolean("why"), false);
    check("getString(\"speed\"): light", map.getString("speed"), "light");

    check("isMapped(\"hi\"): true", map.isMapped("hi"), true);
    check("isMapped(\"bye\"): true", map.isMapped("bye"), true);
    check("isMapped(\"why\"): true", map.isMapped("why"), true);
    check("isMapped(\"speed\"): true", map.isMapped("speed"), true);
    check("isMapped(\"Speed\"): false", map.isMapped("Speed"), false);

    check("isInt(\"hi\"): true", map.isInt("hi"), true);
    check("isDouble(\"bye\"): true", map.isDouble("bye"), true);
    check("isBoolean(\"why\"): true", map.isBoolean("why"), true);
    check("isString(\"speed\"): true", map.isString("speed"), true);

    // Eliminaciones
    map.remove("speed");
    check("remove(\"speed\")", map.isMapped("speed"), false);

    // Enumeracion con llaves 
    StringMap map2= new StringMap();
    map2.put("uno", 1);
    map2.put("dos", 2);
    StringKeyEnum enum= map2.keys();
    check("nextKey()", enum.nextKey(), "uno");
    check("hasMoreKeys()", enum.hasMoreKeys(), true);
    check("nextKey()", enum.nextKey(), "dos");
    check("hasMoreKeys()", enum.hasMoreKeys(), false);
    }

    if (passed)
      println("\nAll test passed.");
    else
      println("\nSome test failed.");
  }

  void check(String s, double t, double v) {
    if (Math.abs(t-v)>0.0000001) {
      passed= false;
      println("Test "+s+" failed.  Value should be "+v+", not "+t);
      println("Type enter to continue");
      readLine();
    }
    else
      println("Test "+s+" passed.");
  }

  void check(String s, String t, String v) {
    if ((t==null && v!=null) || (t!=null && v==null) ||
        (t!=null && v!=null && t.compareTo(v)!=0) ) {
      passed= false;
      println("Test "+s+" failed.  Value should be "+v+", not "+t);
      println("Type enter to continue");
      readLine();
    }
    else
      println("Test "+s+" passed.");
  }

  void check(String s, boolean t, boolean v) {
    if (t!=v) {
      passed= false;
      println("Test "+s+" failed.  Value should be "+v+", not "+t);
      println("Type enter to continue");
      readLine();
    }
    else
      println("Test "+s+" passed.");
  }
}

