import tools.*;
import io.*;

import java.io.*;

class TestQueue extends TestProgram {
  void run() {
    {
    println("Testing Queue");
    Queue q= new Queue();
    check("isEmpty()", q.isEmpty(), true);
    check("size()", q.size(), 0);
    q.put(1);
    check("isEmpty()", q.isEmpty(), false);
    check("size()", q.size(), 1);
    q.put(3.14);
    q.put(3);
    check("isInt()", q.isInt(), true);
    check("firstInt()", q.firstInt(), 1);
    check("getInt()", q.getInt(), 1);
    check("isDouble()", q.isDouble(), true);
    check("isInt()", q.isInt(), false);
    check("firstDouble()", q.firstDouble(), 3.14);
    check("getDouble()", q.getDouble(), 3.14);
    q.put("hola");
    check("size()", q.size(), 2);
    check("isDouble()", q.isDouble(), true);
    check("firstDouble()", q.firstDouble(), 3.0);
    check("getDouble()", q.getDouble(), 3.0);
    check("isString()", q.isString(), true);
    check("isDouble()", q.isDouble(), false);
    check("firstString()", q.firstString(), "hola");
    check("getString()", q.getString(), "hola");
    q.put(true);
    check("isBoolean()", q.isBoolean(), true);
    check("isString()", q.isString(), false);
    check("firstBoolean()", q.firstBoolean(), true);
    check("getBoolean()", q.getBoolean(), true);
    check("isEmpty()", q.isEmpty(), true);
    // q.put(3.14);
    // println(q.getInt());
    }

    {
    println("Testing Stack");
    Stack q= new Stack();
    check("isEmpty()", q.isEmpty(), true);
    check("size()", q.size(), 0);
    q.push(1); // 1
    check("isEmpty()", q.isEmpty(), false);
    check("size()", q.size(), 1);
    q.push(3.14); // 1, 3.14
    q.push(3);    // 1, 3.14, 3
    check("isDouble()", q.isDouble(), true);
    check("isBoolean()", q.isBoolean(), false);
    check("firstDouble()", q.firstDouble(), 3.0);
    check("popDouble()", q.popDouble(), 3.0); // 1, 3.14
    check("isDouble()", q.isDouble(), true);
    check("isString()", q.isString(), false);
    check("isInt()", q.isInt(), false);
    check("firstDouble()", q.firstDouble(), 3.14);
    check("popDouble()", q.popDouble(), 3.14); // 1
    q.push("hola"); // 1, "hola"
    check("size()", q.size(), 2);
    check("isString()", q.isString(), true);
    check("isDouble()", q.isDouble(), false);
    check("firstString()", q.firstString(), "hola");
    check("popString()", q.popString(), "hola"); // 1
    check("firstInt()", q.firstInt(), 1);
    check("isInt()", q.isInt(), true);
    check("popInt()", q.popInt(), 1); //
    q.push(true); // true
    check("isBoolean()", q.isBoolean(), true);
    check("firstBoolean()", q.firstBoolean(), true);
    check("popBoolean()", q.popBoolean(), true); //
    check("isEmpty()", q.isEmpty(), true);
    // q.push(3.14);
    // println(q.popInt());
    }

    if (passed)
      println("\nAll test passed.");
    else
      println("\nSome test failed.");
  }
}

