package tools;

import io.*;
import java.io.*;

public class LogConsole extends TextConsole {

  TextConsole cons;
  PrintWriter logWriter= null; 

  public LogConsole(TextConsole cons, String fn) throws IOException {
    this.cons= cons;
    logWriter= new PrintWriter(new BufferedWriter(new FileWriter(fn)));
  }

  public void print(String s) {
    cons.print(s);
    logWriter.print(s);
    logWriter.flush();
  }
  public void println() {
    cons.println();
    logWriter.println();
    logWriter.flush();
  }
  public String readLine() {
    String s= cons.readLine();
    logWriter.println(s);
    logWriter.flush();
    return s;
  }
  public String readString() {
    String s= cons.readString();
    logWriter.print(s);
    logWriter.flush();
    return s;
  }
}
