// Observacion: este programa usa caracteristicas avanzadas del
// lenguaje Java, como reflexion.  No intente comprender este programa
// a menos que Ud. se considere un experto en Java.

package tools;

import java.io.*;
import console.*;

public abstract class Tools {
  public static String version="version 1.2, 21 de Junio de 1999";

  static StdConsole stdCons= new StdConsole();
  static Console graphCons= null;
  static TextConsole cons= stdCons;

  public static final int MAXINT= Integer.MAX_VALUE;
  public static final int MININT= Integer.MIN_VALUE;
  public static final double MAXDOUBLE= Integer.MAX_VALUE;
  public static final double MINDOUBLE= Integer.MIN_VALUE;

  // Creacion del archivo de log
  static PrintWriter logWriter= null;
  public static void setLogFile(String fn) {
    try {
      cons= new LogConsole(cons, fn);
    }
    catch ( IOException excp ) {
      println("Warning: Could not create log file\n");
    }
  }

  public static Console getGraphConsole() {
    if (graphCons==null)
      graphCons= new Console();
    return graphCons;
  }
  public static void setGraphConsole() {
    if (graphCons==null)
      graphCons= new Console();
    cons= new GraphConsole(graphCons);
  }

  public static StdConsole getStdConsole() { return stdCons; }
  public static void setStdConsole() { cons= stdCons; }

  public static TextConsole getTextConsole() { return cons; }

  // Manejo de la salida en la consola
  public static void print(String s) { cons.print(s); }
  public static void print(char c) { cons.print(c); }
  public static void print(int n) { cons.print(n); }
  public static void print(long n) { cons.print(n); }
  public static void print(double x) { cons.print(x); }
  public static void print(float x) { cons.print(x); }
  public static void print(boolean b) { cons.print(b); }
  public static void println() { cons.println(); }
  public static void println(String s) { cons.println(s); }
  public static void println(char c) { cons.println(c); }
  public static void println(int n) { cons.println(n); }
  public static void println(long n) { cons.println(n); }
  public static void println(double x) { cons.println(x); }
  public static void println(float x) { cons.println(x); }
  public static void println(boolean b) { cons.println(b); }

  // Manejo de la entrada en la consola

  public static String readLine() { return cons.readLine(); }
  public static String readString() { return cons.readString(); }
  public static int readInt() { return cons.readInt(); }
  public static double readDouble() { return cons.readDouble(); }
  public static boolean readBoolean() { return cons.readBoolean(); }

  public static void exit() { throw new FinishException(); }

  // Largos de strings y arreglos
  public static int length(String s) { return s.length(); }
  public static int length(int[] a) { return a.length; }
  public static int length(double[] a) { return a.length; }
  public static int length(boolean[] a) { return a.length; }
  public static int length(Object[] a) { return a.length; }

  // Funciones trigonometricas
  public static final double PI= Math.PI;
  public static double sin(double a) { return Math.sin(a); }
  public static double cos(double a) { return Math.cos(a); }
  public static double tan(double a) { return Math.tan(a); }

  public static double asin(double a) { return Math.asin(a); }
  public static double acos(double a) { return Math.acos(a); }
  public static double atan(double a) { return Math.atan(a); }

  // Funciones matematicas
  public static final double E= Math.E;
  public static double exp(double a) { return Math.exp(a); }
  public static double log(double a) { return Math.log(a); }
  public static double pow(double a, double b) { return Math.pow(a, b); }
  public static double sqrt(double a) { return Math.sqrt(a); }
  public static double ceil(double a) { return Math.ceil(a); }
  public static double floor(double a) { return Math.floor(a); }
  public static int trunc(double a) {
    if (a>Integer.MAX_VALUE || a<Integer.MIN_VALUE)
      throw new ArithmeticException(
        "trunc: value "+a+" can't be represented by an int");
    return (int)a;
  }

  public static double random() { return Math.random(); }
  public static double abs(double a) { return Math.abs(a); }
  public static int abs(int a) { return Math.abs(a); }
  public static double max(double a, double b) { return Math.max(a, b); }
  public static int max(int a, int b) { return Math.max(a, b); }
  public static double min(double a, double b) { return Math.min(a, b); }
  public static int min(int a, int b) { return Math.min(a, b); }

  public static double round(double a) { return Math.round(a); }
  public static double round(double a, int dec) {
    double fac= pow(10.0, dec);
    return Math.round(a*fac)/fac;
  } 

  public static int parseInt(String s) { return Integer.parseInt(s); }
  public static double parseDouble(String s) {
    return new Double(s).doubleValue();
  }

  // Strings
  public static int compare(String s, String r) { return s.compareTo(r); }
  public static int indexOf(String s, String sub) {
    return s.indexOf(sub);
  }
  public static int indexOf(String s, String sub, int i) {
    return s.indexOf(sub, i);
  }
  public static String substring(String s, int i, int n) {
    return s.substring(i,i+n);
  }
  public static String substring(String s, int i) {
    return s.substring(i);
  }
  public static String repeat(String s, int n) {
    String ret= s;
    for(int i= 1; i<n; i++)
      ret+= s;
    return ret;
  }
  public static String replace(String s, String tg, String by) {
    String res= "";
    int lasti= 0;
    int i= s.indexOf(tg);
    while (i!=-1) {
      res= res+s.substring(lasti, i)+by;
      lasti= i+length(tg);
      i= s.indexOf(tg, lasti);
    }
    res= res+s.substring(lasti);
    return res;
  }
  public static String trim(String s) { return s.trim(); }
  public static String lower(String s) { return s.toLowerCase(); }
  public static String upper(String s) { return s.toUpperCase(); }
  public static boolean isInt(String s) {
    try {
      int i= parseInt(s);
      return true;
    }
    catch (NumberFormatException excp) {
      return false;
    }
  }
  public static boolean isDouble(String s) { 
    try {
      double x= new Double(s).doubleValue();
      return true;
    }
    catch (NumberFormatException excp) {
      return false;
    }
  }

  public static void sleep(double secs) {
    try {
      Thread.sleep(trunc(secs*1000));
    }
    catch (InterruptedException excp) {
      throw new ProgramException(excp);
    }
  }

  public static void fatalError(String msg) {
    throw new ProgramException(msg);
  }

}
